﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace WindowsFormsApplication1
{
    public partial class BattleVideoManager : Form
    {
        public BattleVideoManager()
        {
            InitializeComponent();
            L_N.Visible = false;
            var species_list = new[] {
                    new { Text = "", Value = 0 },
                    new { Text = "Abomasnow", Value = 460 },
                    new { Text = "Abra", Value = 63 },
                    new { Text = "Absol", Value = 359 },
                    new { Text = "Accelgor", Value = 617 },
                    new { Text = "Aegislash", Value = 681 },
                    new { Text = "Aerodactyl", Value = 142 },
                    new { Text = "Aggron", Value = 306 },
                    new { Text = "Aipom", Value = 190 },
                    new { Text = "Alakazam", Value = 65 },
                    new { Text = "Alomomola", Value = 594 },
                    new { Text = "Altaria", Value = 334 },
                    new { Text = "Amaura", Value = 698 },
                    new { Text = "Ambipom", Value = 424 },
                    new { Text = "Amoonguss", Value = 591 },
                    new { Text = "Ampharos", Value = 181 },
                    new { Text = "Anorith", Value = 347 },
                    new { Text = "Arbok", Value = 24 },
                    new { Text = "Arcanine", Value = 59 },
                    new { Text = "Arceus", Value = 493 },
                    new { Text = "Archen", Value = 566 },
                    new { Text = "Archeops", Value = 567 },
                    new { Text = "Ariados", Value = 168 },
                    new { Text = "Armaldo", Value = 348 },
                    new { Text = "Aromatisse", Value = 683 },
                    new { Text = "Aron", Value = 304 },
                    new { Text = "Articuno", Value = 144 },
                    new { Text = "Audino", Value = 531 },
                    new { Text = "Aurorus", Value = 699 },
                    new { Text = "Avalugg", Value = 713 },
                    new { Text = "Axew", Value = 610 },
                    new { Text = "Azelf", Value = 482 },
                    new { Text = "Azumarill", Value = 184 },
                    new { Text = "Azurill", Value = 298 },
                    new { Text = "Bagon", Value = 371 },
                    new { Text = "Baltoy", Value = 343 },
                    new { Text = "Banette", Value = 354 },
                    new { Text = "Barbaracle", Value = 689 },
                    new { Text = "Barboach", Value = 339 },
                    new { Text = "Basculin", Value = 550 },
                    new { Text = "Bastiodon", Value = 411 },
                    new { Text = "Bayleef", Value = 153 },
                    new { Text = "Beartic", Value = 614 },
                    new { Text = "Beautifly", Value = 267 },
                    new { Text = "Beedrill", Value = 15 },
                    new { Text = "Beheeyem", Value = 606 },
                    new { Text = "Beldum", Value = 374 },
                    new { Text = "Bellossom", Value = 182 },
                    new { Text = "Bellsprout", Value = 69 },
                    new { Text = "Bergmite", Value = 712 },
                    new { Text = "Bibarel", Value = 400 },
                    new { Text = "Bidoof", Value = 399 },
                    new { Text = "Binacle", Value = 688 },
                    new { Text = "Bisharp", Value = 625 },
                    new { Text = "Blastoise", Value = 9 },
                    new { Text = "Blaziken", Value = 257 },
                    new { Text = "Blissey", Value = 242 },
                    new { Text = "Blitzle", Value = 522 },
                    new { Text = "Boldore", Value = 525 },
                    new { Text = "Bonsly", Value = 438 },
                    new { Text = "Bouffalant", Value = 626 },
                    new { Text = "Braixen", Value = 654 },
                    new { Text = "Braviary", Value = 628 },
                    new { Text = "Breloom", Value = 286 },
                    new { Text = "Bronzong", Value = 437 },
                    new { Text = "Bronzor", Value = 436 },
                    new { Text = "Budew", Value = 406 },
                    new { Text = "Buizel", Value = 418 },
                    new { Text = "Bulbasaur", Value = 1 },
                    new { Text = "Buneary", Value = 427 },
                    new { Text = "Bunnelby", Value = 659 },
                    new { Text = "Burmy", Value = 412 },
                    new { Text = "Butterfree", Value = 12 },
                    new { Text = "Cacnea", Value = 331 },
                    new { Text = "Cacturne", Value = 332 },
                    new { Text = "Camerupt", Value = 323 },
                    new { Text = "Carbink", Value = 703 },
                    new { Text = "Carnivine", Value = 455 },
                    new { Text = "Carracosta", Value = 565 },
                    new { Text = "Carvanha", Value = 318 },
                    new { Text = "Cascoon", Value = 268 },
                    new { Text = "Castform", Value = 351 },
                    new { Text = "Caterpie", Value = 10 },
                    new { Text = "Celebi", Value = 251 },
                    new { Text = "Chandelure", Value = 609 },
                    new { Text = "Chansey", Value = 113 },
                    new { Text = "Charizard", Value = 6 },
                    new { Text = "Charmander", Value = 4 },
                    new { Text = "Charmeleon", Value = 5 },
                    new { Text = "Chatot", Value = 441 },
                    new { Text = "Cherrim", Value = 421 },
                    new { Text = "Cherubi", Value = 420 },
                    new { Text = "Chesnaught", Value = 652 },
                    new { Text = "Chespin", Value = 650 },
                    new { Text = "Chikorita", Value = 152 },
                    new { Text = "Chimchar", Value = 390 },
                    new { Text = "Chimecho", Value = 358 },
                    new { Text = "Chinchou", Value = 170 },
                    new { Text = "Chingling", Value = 433 },
                    new { Text = "Cinccino", Value = 573 },
                    new { Text = "Clamperl", Value = 366 },
                    new { Text = "Clauncher", Value = 692 },
                    new { Text = "Clawitzer", Value = 693 },
                    new { Text = "Claydol", Value = 344 },
                    new { Text = "Clefable", Value = 36 },
                    new { Text = "Clefairy", Value = 35 },
                    new { Text = "Cleffa", Value = 173 },
                    new { Text = "Cloyster", Value = 91 },
                    new { Text = "Cobalion", Value = 638 },
                    new { Text = "Cofagrigus", Value = 563 },
                    new { Text = "Combee", Value = 415 },
                    new { Text = "Combusken", Value = 256 },
                    new { Text = "Conkeldurr", Value = 534 },
                    new { Text = "Corphish", Value = 341 },
                    new { Text = "Corsola", Value = 222 },
                    new { Text = "Cottonee", Value = 546 },
                    new { Text = "Cradily", Value = 346 },
                    new { Text = "Cranidos", Value = 408 },
                    new { Text = "Crawdaunt", Value = 342 },
                    new { Text = "Cresselia", Value = 488 },
                    new { Text = "Croagunk", Value = 453 },
                    new { Text = "Crobat", Value = 169 },
                    new { Text = "Croconaw", Value = 159 },
                    new { Text = "Crustle", Value = 558 },
                    new { Text = "Cryogonal", Value = 615 },
                    new { Text = "Cubchoo", Value = 613 },
                    new { Text = "Cubone", Value = 104 },
                    new { Text = "Cyndaquil", Value = 155 },
                    new { Text = "Darkrai", Value = 491 },
                    new { Text = "Darmanitan", Value = 555 },
                    new { Text = "Darumaka", Value = 554 },
                    new { Text = "Dedenne", Value = 702 },
                    new { Text = "Deerling", Value = 585 },
                    new { Text = "Deino", Value = 633 },
                    new { Text = "Delcatty", Value = 301 },
                    new { Text = "Delibird", Value = 225 },
                    new { Text = "Delphox", Value = 655 },
                    new { Text = "Deoxys", Value = 386 },
                    new { Text = "Dewgong", Value = 87 },
                    new { Text = "Dewott", Value = 502 },
                    new { Text = "Dialga", Value = 483 },
                    new { Text = "Diancie", Value = 719 },
                    new { Text = "Diggersby", Value = 660 },
                    new { Text = "Diglett", Value = 50 },
                    new { Text = "Ditto", Value = 132 },
                    new { Text = "Dodrio", Value = 85 },
                    new { Text = "Doduo", Value = 84 },
                    new { Text = "Donphan", Value = 232 },
                    new { Text = "Doublade", Value = 680 },
                    new { Text = "Dragalge", Value = 691 },
                    new { Text = "Dragonair", Value = 148 },
                    new { Text = "Dragonite", Value = 149 },
                    new { Text = "Drapion", Value = 452 },
                    new { Text = "Dratini", Value = 147 },
                    new { Text = "Drifblim", Value = 426 },
                    new { Text = "Drifloon", Value = 425 },
                    new { Text = "Drilbur", Value = 529 },
                    new { Text = "Drowzee", Value = 96 },
                    new { Text = "Druddigon", Value = 621 },
                    new { Text = "Ducklett", Value = 580 },
                    new { Text = "Dugtrio", Value = 51 },
                    new { Text = "Dunsparce", Value = 206 },
                    new { Text = "Duosion", Value = 578 },
                    new { Text = "Durant", Value = 632 },
                    new { Text = "Dusclops", Value = 356 },
                    new { Text = "Dusknoir", Value = 477 },
                    new { Text = "Duskull", Value = 355 },
                    new { Text = "Dustox", Value = 269 },
                    new { Text = "Dwebble", Value = 557 },
                    new { Text = "Eelektrik", Value = 603 },
                    new { Text = "Eelektross", Value = 604 },
                    new { Text = "Eevee", Value = 133 },
                    new { Text = "Ekans", Value = 23 },
                    new { Text = "Electabuzz", Value = 125 },
                    new { Text = "Electivire", Value = 466 },
                    new { Text = "Electrike", Value = 309 },
                    new { Text = "Electrode", Value = 101 },
                    new { Text = "Elekid", Value = 239 },
                    new { Text = "Elgyem", Value = 605 },
                    new { Text = "Emboar", Value = 500 },
                    new { Text = "Emolga", Value = 587 },
                    new { Text = "Empoleon", Value = 395 },
                    new { Text = "Entei", Value = 244 },
                    new { Text = "Escavalier", Value = 589 },
                    new { Text = "Espeon", Value = 196 },
                    new { Text = "Espurr", Value = 677 },
                    new { Text = "Excadrill", Value = 530 },
                    new { Text = "Exeggcute", Value = 102 },
                    new { Text = "Exeggutor", Value = 103 },
                    new { Text = "Exploud", Value = 295 },
                    new { Text = "Farfetch'd", Value = 83 },
                    new { Text = "Fearow", Value = 22 },
                    new { Text = "Feebas", Value = 349 },
                    new { Text = "Fennekin", Value = 653 },
                    new { Text = "Feraligatr", Value = 160 },
                    new { Text = "Ferroseed", Value = 597 },
                    new { Text = "Ferrothorn", Value = 598 },
                    new { Text = "Finneon", Value = 456 },
                    new { Text = "Flaaffy", Value = 180 },
                    new { Text = "Flabébé", Value = 669 },
                    new { Text = "Flareon", Value = 136 },
                    new { Text = "Fletchinder", Value = 662 },
                    new { Text = "Fletchling", Value = 661 },
                    new { Text = "Floatzel", Value = 419 },
                    new { Text = "Floette", Value = 670 },
                    new { Text = "Florges", Value = 671 },
                    new { Text = "Flygon", Value = 330 },
                    new { Text = "Foongus", Value = 590 },
                    new { Text = "Forretress", Value = 205 },
                    new { Text = "Fraxure", Value = 611 },
                    new { Text = "Frillish", Value = 592 },
                    new { Text = "Froakie", Value = 656 },
                    new { Text = "Frogadier", Value = 657 },
                    new { Text = "Froslass", Value = 478 },
                    new { Text = "Furfrou", Value = 676 },
                    new { Text = "Furret", Value = 162 },
                    new { Text = "Gabite", Value = 444 },
                    new { Text = "Gallade", Value = 475 },
                    new { Text = "Galvantula", Value = 596 },
                    new { Text = "Garbodor", Value = 569 },
                    new { Text = "Garchomp", Value = 445 },
                    new { Text = "Gardevoir", Value = 282 },
                    new { Text = "Gastly", Value = 92 },
                    new { Text = "Gastrodon", Value = 423 },
                    new { Text = "Genesect", Value = 649 },
                    new { Text = "Gengar", Value = 94 },
                    new { Text = "Geodude", Value = 74 },
                    new { Text = "Gible", Value = 443 },
                    new { Text = "Gigalith", Value = 526 },
                    new { Text = "Girafarig", Value = 203 },
                    new { Text = "Giratina", Value = 487 },
                    new { Text = "Glaceon", Value = 471 },
                    new { Text = "Glalie", Value = 362 },
                    new { Text = "Glameow", Value = 431 },
                    new { Text = "Gligar", Value = 207 },
                    new { Text = "Gliscor", Value = 472 },
                    new { Text = "Gloom", Value = 44 },
                    new { Text = "Gogoat", Value = 673 },
                    new { Text = "Golbat", Value = 42 },
                    new { Text = "Goldeen", Value = 118 },
                    new { Text = "Golduck", Value = 55 },
                    new { Text = "Golem", Value = 76 },
                    new { Text = "Golett", Value = 622 },
                    new { Text = "Golurk", Value = 623 },
                    new { Text = "Goodra", Value = 706 },
                    new { Text = "Goomy", Value = 704 },
                    new { Text = "Gorebyss", Value = 368 },
                    new { Text = "Gothita", Value = 574 },
                    new { Text = "Gothitelle", Value = 576 },
                    new { Text = "Gothorita", Value = 575 },
                    new { Text = "Gourgeist", Value = 711 },
                    new { Text = "Granbull", Value = 210 },
                    new { Text = "Graveler", Value = 75 },
                    new { Text = "Greninja", Value = 658 },
                    new { Text = "Grimer", Value = 88 },
                    new { Text = "Grotle", Value = 388 },
                    new { Text = "Groudon", Value = 383 },
                    new { Text = "Grovyle", Value = 253 },
                    new { Text = "Growlithe", Value = 58 },
                    new { Text = "Grumpig", Value = 326 },
                    new { Text = "Gulpin", Value = 316 },
                    new { Text = "Gurdurr", Value = 533 },
                    new { Text = "Gyarados", Value = 130 },
                    new { Text = "Happiny", Value = 440 },
                    new { Text = "Hariyama", Value = 297 },
                    new { Text = "Haunter", Value = 93 },
                    new { Text = "Hawlucha", Value = 701 },
                    new { Text = "Haxorus", Value = 612 },
                    new { Text = "Heatmor", Value = 631 },
                    new { Text = "Heatran", Value = 485 },
                    new { Text = "Heliolisk", Value = 695 },
                    new { Text = "Helioptile", Value = 694 },
                    new { Text = "Heracross", Value = 214 },
                    new { Text = "Herdier", Value = 507 },
                    new { Text = "Hippopotas", Value = 449 },
                    new { Text = "Hippowdon", Value = 450 },
                    new { Text = "Hitmonchan", Value = 107 },
                    new { Text = "Hitmonlee", Value = 106 },
                    new { Text = "Hitmontop", Value = 237 },
                    new { Text = "Honchkrow", Value = 430 },
                    new { Text = "Honedge", Value = 679 },
                    new { Text = "Ho-Oh", Value = 250 },
                    new { Text = "Hoopa", Value = 720 },
                    new { Text = "Hoothoot", Value = 163 },
                    new { Text = "Hoppip", Value = 187 },
                    new { Text = "Horsea", Value = 116 },
                    new { Text = "Houndoom", Value = 229 },
                    new { Text = "Houndour", Value = 228 },
                    new { Text = "Huntail", Value = 367 },
                    new { Text = "Hydreigon", Value = 635 },
                    new { Text = "Hypno", Value = 97 },
                    new { Text = "Igglybuff", Value = 174 },
                    new { Text = "Illumise", Value = 314 },
                    new { Text = "Infernape", Value = 392 },
                    new { Text = "Inkay", Value = 686 },
                    new { Text = "Ivysaur", Value = 2 },
                    new { Text = "Jellicent", Value = 593 },
                    new { Text = "Jigglypuff", Value = 39 },
                    new { Text = "Jirachi", Value = 385 },
                    new { Text = "Jolteon", Value = 135 },
                    new { Text = "Joltik", Value = 595 },
                    new { Text = "Jumpluff", Value = 189 },
                    new { Text = "Jynx", Value = 124 },
                    new { Text = "Kabuto", Value = 140 },
                    new { Text = "Kabutops", Value = 141 },
                    new { Text = "Kadabra", Value = 64 },
                    new { Text = "Kakuna", Value = 14 },
                    new { Text = "Kangaskhan", Value = 115 },
                    new { Text = "Karrablast", Value = 588 },
                    new { Text = "Kecleon", Value = 352 },
                    new { Text = "Keldeo", Value = 647 },
                    new { Text = "Kingdra", Value = 230 },
                    new { Text = "Kingler", Value = 99 },
                    new { Text = "Kirlia", Value = 281 },
                    new { Text = "Klang", Value = 600 },
                    new { Text = "Klefki", Value = 707 },
                    new { Text = "Klink", Value = 599 },
                    new { Text = "Klinklang", Value = 601 },
                    new { Text = "Koffing", Value = 109 },
                    new { Text = "Krabby", Value = 98 },
                    new { Text = "Kricketot", Value = 401 },
                    new { Text = "Kricketune", Value = 402 },
                    new { Text = "Krokorok", Value = 552 },
                    new { Text = "Krookodile", Value = 553 },
                    new { Text = "Kyogre", Value = 382 },
                    new { Text = "Kyurem", Value = 646 },
                    new { Text = "Lairon", Value = 305 },
                    new { Text = "Lampent", Value = 608 },
                    new { Text = "Landorus", Value = 645 },
                    new { Text = "Lanturn", Value = 171 },
                    new { Text = "Lapras", Value = 131 },
                    new { Text = "Larvesta", Value = 636 },
                    new { Text = "Larvitar", Value = 246 },
                    new { Text = "Latias", Value = 380 },
                    new { Text = "Latios", Value = 381 },
                    new { Text = "Leafeon", Value = 470 },
                    new { Text = "Leavanny", Value = 542 },
                    new { Text = "Ledian", Value = 166 },
                    new { Text = "Ledyba", Value = 165 },
                    new { Text = "Lickilicky", Value = 463 },
                    new { Text = "Lickitung", Value = 108 },
                    new { Text = "Liepard", Value = 510 },
                    new { Text = "Lileep", Value = 345 },
                    new { Text = "Lilligant", Value = 549 },
                    new { Text = "Lillipup", Value = 506 },
                    new { Text = "Linoone", Value = 264 },
                    new { Text = "Litleo", Value = 667 },
                    new { Text = "Litwick", Value = 607 },
                    new { Text = "Lombre", Value = 271 },
                    new { Text = "Lopunny", Value = 428 },
                    new { Text = "Lotad", Value = 270 },
                    new { Text = "Loudred", Value = 294 },
                    new { Text = "Lucario", Value = 448 },
                    new { Text = "Ludicolo", Value = 272 },
                    new { Text = "Lugia", Value = 249 },
                    new { Text = "Lumineon", Value = 457 },
                    new { Text = "Lunatone", Value = 337 },
                    new { Text = "Luvdisc", Value = 370 },
                    new { Text = "Luxio", Value = 404 },
                    new { Text = "Luxray", Value = 405 },
                    new { Text = "Machamp", Value = 68 },
                    new { Text = "Machoke", Value = 67 },
                    new { Text = "Machop", Value = 66 },
                    new { Text = "Magby", Value = 240 },
                    new { Text = "Magcargo", Value = 219 },
                    new { Text = "Magikarp", Value = 129 },
                    new { Text = "Magmar", Value = 126 },
                    new { Text = "Magmortar", Value = 467 },
                    new { Text = "Magnemite", Value = 81 },
                    new { Text = "Magneton", Value = 82 },
                    new { Text = "Magnezone", Value = 462 },
                    new { Text = "Makuhita", Value = 296 },
                    new { Text = "Malamar", Value = 687 },
                    new { Text = "Mamoswine", Value = 473 },
                    new { Text = "Manaphy", Value = 490 },
                    new { Text = "Mandibuzz", Value = 630 },
                    new { Text = "Manectric", Value = 310 },
                    new { Text = "Mankey", Value = 56 },
                    new { Text = "Mantine", Value = 226 },
                    new { Text = "Mantyke", Value = 458 },
                    new { Text = "Maractus", Value = 556 },
                    new { Text = "Mareep", Value = 179 },
                    new { Text = "Marill", Value = 183 },
                    new { Text = "Marowak", Value = 105 },
                    new { Text = "Marshtomp", Value = 259 },
                    new { Text = "Masquerain", Value = 284 },
                    new { Text = "Mawile", Value = 303 },
                    new { Text = "Medicham", Value = 308 },
                    new { Text = "Meditite", Value = 307 },
                    new { Text = "Meganium", Value = 154 },
                    new { Text = "Meloetta", Value = 648 },
                    new { Text = "Meowstic", Value = 678 },
                    new { Text = "Meowth", Value = 52 },
                    new { Text = "Mesprit", Value = 481 },
                    new { Text = "Metagross", Value = 376 },
                    new { Text = "Metang", Value = 375 },
                    new { Text = "Metapod", Value = 11 },
                    new { Text = "Mew", Value = 151 },
                    new { Text = "Mewtwo", Value = 150 },
                    new { Text = "Mienfoo", Value = 619 },
                    new { Text = "Mienshao", Value = 620 },
                    new { Text = "Mightyena", Value = 262 },
                    new { Text = "Milotic", Value = 350 },
                    new { Text = "Miltank", Value = 241 },
                    new { Text = "Mime Jr.", Value = 439 },
                    new { Text = "Minccino", Value = 572 },
                    new { Text = "Minun", Value = 312 },
                    new { Text = "Misdreavus", Value = 200 },
                    new { Text = "Mismagius", Value = 429 },
                    new { Text = "Moltres", Value = 146 },
                    new { Text = "Monferno", Value = 391 },
                    new { Text = "Mothim", Value = 414 },
                    new { Text = "Mr. Mime", Value = 122 },
                    new { Text = "Mudkip", Value = 258 },
                    new { Text = "Muk", Value = 89 },
                    new { Text = "Munchlax", Value = 446 },
                    new { Text = "Munna", Value = 517 },
                    new { Text = "Murkrow", Value = 198 },
                    new { Text = "Musharna", Value = 518 },
                    new { Text = "Natu", Value = 177 },
                    new { Text = "Nidoking", Value = 34 },
                    new { Text = "Nidoqueen", Value = 31 },
                    new { Text = "Nidoran♀", Value = 29 },
                    new { Text = "Nidoran♂", Value = 32 },
                    new { Text = "Nidorina", Value = 30 },
                    new { Text = "Nidorino", Value = 33 },
                    new { Text = "Nincada", Value = 290 },
                    new { Text = "Ninetales", Value = 38 },
                    new { Text = "Ninjask", Value = 291 },
                    new { Text = "Noctowl", Value = 164 },
                    new { Text = "Noibat", Value = 714 },
                    new { Text = "Noivern", Value = 715 },
                    new { Text = "Nosepass", Value = 299 },
                    new { Text = "Numel", Value = 322 },
                    new { Text = "Nuzleaf", Value = 274 },
                    new { Text = "Octillery", Value = 224 },
                    new { Text = "Oddish", Value = 43 },
                    new { Text = "Omanyte", Value = 138 },
                    new { Text = "Omastar", Value = 139 },
                    new { Text = "Onix", Value = 95 },
                    new { Text = "Oshawott", Value = 501 },
                    new { Text = "Pachirisu", Value = 417 },
                    new { Text = "Palkia", Value = 484 },
                    new { Text = "Palpitoad", Value = 536 },
                    new { Text = "Pancham", Value = 674 },
                    new { Text = "Pangoro", Value = 675 },
                    new { Text = "Panpour", Value = 515 },
                    new { Text = "Pansage", Value = 511 },
                    new { Text = "Pansear", Value = 513 },
                    new { Text = "Paras", Value = 46 },
                    new { Text = "Parasect", Value = 47 },
                    new { Text = "Patrat", Value = 504 },
                    new { Text = "Pawniard", Value = 624 },
                    new { Text = "Pelipper", Value = 279 },
                    new { Text = "Persian", Value = 53 },
                    new { Text = "Petilil", Value = 548 },
                    new { Text = "Phanpy", Value = 231 },
                    new { Text = "Phantump", Value = 708 },
                    new { Text = "Phione", Value = 489 },
                    new { Text = "Pichu", Value = 172 },
                    new { Text = "Pidgeot", Value = 18 },
                    new { Text = "Pidgeotto", Value = 17 },
                    new { Text = "Pidgey", Value = 16 },
                    new { Text = "Pidove", Value = 519 },
                    new { Text = "Pignite", Value = 499 },
                    new { Text = "Pikachu", Value = 25 },
                    new { Text = "Piloswine", Value = 221 },
                    new { Text = "Pineco", Value = 204 },
                    new { Text = "Pinsir", Value = 127 },
                    new { Text = "Piplup", Value = 393 },
                    new { Text = "Plusle", Value = 311 },
                    new { Text = "Politoed", Value = 186 },
                    new { Text = "Poliwag", Value = 60 },
                    new { Text = "Poliwhirl", Value = 61 },
                    new { Text = "Poliwrath", Value = 62 },
                    new { Text = "Ponyta", Value = 77 },
                    new { Text = "Poochyena", Value = 261 },
                    new { Text = "Porygon", Value = 137 },
                    new { Text = "Porygon2", Value = 233 },
                    new { Text = "Porygon-Z", Value = 474 },
                    new { Text = "Primeape", Value = 57 },
                    new { Text = "Prinplup", Value = 394 },
                    new { Text = "Probopass", Value = 476 },
                    new { Text = "Psyduck", Value = 54 },
                    new { Text = "Pumpkaboo", Value = 710 },
                    new { Text = "Pupitar", Value = 247 },
                    new { Text = "Purrloin", Value = 509 },
                    new { Text = "Purugly", Value = 432 },
                    new { Text = "Pyroar", Value = 668 },
                    new { Text = "Quagsire", Value = 195 },
                    new { Text = "Quilava", Value = 156 },
                    new { Text = "Quilladin", Value = 651 },
                    new { Text = "Qwilfish", Value = 211 },
                    new { Text = "Raichu", Value = 26 },
                    new { Text = "Raikou", Value = 243 },
                    new { Text = "Ralts", Value = 280 },
                    new { Text = "Rampardos", Value = 409 },
                    new { Text = "Rapidash", Value = 78 },
                    new { Text = "Raticate", Value = 20 },
                    new { Text = "Rattata", Value = 19 },
                    new { Text = "Rayquaza", Value = 384 },
                    new { Text = "Regice", Value = 378 },
                    new { Text = "Regigigas", Value = 486 },
                    new { Text = "Regirock", Value = 377 },
                    new { Text = "Registeel", Value = 379 },
                    new { Text = "Relicanth", Value = 369 },
                    new { Text = "Remoraid", Value = 223 },
                    new { Text = "Reshiram", Value = 643 },
                    new { Text = "Reuniclus", Value = 579 },
                    new { Text = "Rhydon", Value = 112 },
                    new { Text = "Rhyhorn", Value = 111 },
                    new { Text = "Rhyperior", Value = 464 },
                    new { Text = "Riolu", Value = 447 },
                    new { Text = "Roggenrola", Value = 524 },
                    new { Text = "Roselia", Value = 315 },
                    new { Text = "Roserade", Value = 407 },
                    new { Text = "Rotom", Value = 479 },
                    new { Text = "Rufflet", Value = 627 },
                    new { Text = "Sableye", Value = 302 },
                    new { Text = "Salamence", Value = 373 },
                    new { Text = "Samurott", Value = 503 },
                    new { Text = "Sandile", Value = 551 },
                    new { Text = "Sandshrew", Value = 27 },
                    new { Text = "Sandslash", Value = 28 },
                    new { Text = "Sawk", Value = 539 },
                    new { Text = "Sawsbuck", Value = 586 },
                    new { Text = "Scatterbug", Value = 664 },
                    new { Text = "Sceptile", Value = 254 },
                    new { Text = "Scizor", Value = 212 },
                    new { Text = "Scolipede", Value = 545 },
                    new { Text = "Scrafty", Value = 560 },
                    new { Text = "Scraggy", Value = 559 },
                    new { Text = "Scyther", Value = 123 },
                    new { Text = "Seadra", Value = 117 },
                    new { Text = "Seaking", Value = 119 },
                    new { Text = "Sealeo", Value = 364 },
                    new { Text = "Seedot", Value = 273 },
                    new { Text = "Seel", Value = 86 },
                    new { Text = "Seismitoad", Value = 537 },
                    new { Text = "Sentret", Value = 161 },
                    new { Text = "Serperior", Value = 497 },
                    new { Text = "Servine", Value = 496 },
                    new { Text = "Seviper", Value = 336 },
                    new { Text = "Sewaddle", Value = 540 },
                    new { Text = "Sharpedo", Value = 319 },
                    new { Text = "Shaymin", Value = 492 },
                    new { Text = "Shedinja", Value = 292 },
                    new { Text = "Shelgon", Value = 372 },
                    new { Text = "Shellder", Value = 90 },
                    new { Text = "Shellos", Value = 422 },
                    new { Text = "Shelmet", Value = 616 },
                    new { Text = "Shieldon", Value = 410 },
                    new { Text = "Shiftry", Value = 275 },
                    new { Text = "Shinx", Value = 403 },
                    new { Text = "Shroomish", Value = 285 },
                    new { Text = "Shuckle", Value = 213 },
                    new { Text = "Shuppet", Value = 353 },
                    new { Text = "Sigilyph", Value = 561 },
                    new { Text = "Silcoon", Value = 266 },
                    new { Text = "Simipour", Value = 516 },
                    new { Text = "Simisage", Value = 512 },
                    new { Text = "Simisear", Value = 514 },
                    new { Text = "Skarmory", Value = 227 },
                    new { Text = "Skiddo", Value = 672 },
                    new { Text = "Skiploom", Value = 188 },
                    new { Text = "Skitty", Value = 300 },
                    new { Text = "Skorupi", Value = 451 },
                    new { Text = "Skrelp", Value = 690 },
                    new { Text = "Skuntank", Value = 435 },
                    new { Text = "Slaking", Value = 289 },
                    new { Text = "Slakoth", Value = 287 },
                    new { Text = "Sliggoo", Value = 705 },
                    new { Text = "Slowbro", Value = 80 },
                    new { Text = "Slowking", Value = 199 },
                    new { Text = "Slowpoke", Value = 79 },
                    new { Text = "Slugma", Value = 218 },
                    new { Text = "Slurpuff", Value = 685 },
                    new { Text = "Smeargle", Value = 235 },
                    new { Text = "Smoochum", Value = 238 },
                    new { Text = "Sneasel", Value = 215 },
                    new { Text = "Snivy", Value = 495 },
                    new { Text = "Snorlax", Value = 143 },
                    new { Text = "Snorunt", Value = 361 },
                    new { Text = "Snover", Value = 459 },
                    new { Text = "Snubbull", Value = 209 },
                    new { Text = "Solosis", Value = 577 },
                    new { Text = "Solrock", Value = 338 },
                    new { Text = "Spearow", Value = 21 },
                    new { Text = "Spewpa", Value = 665 },
                    new { Text = "Spheal", Value = 363 },
                    new { Text = "Spinarak", Value = 167 },
                    new { Text = "Spinda", Value = 327 },
                    new { Text = "Spiritomb", Value = 442 },
                    new { Text = "Spoink", Value = 325 },
                    new { Text = "Spritzee", Value = 682 },
                    new { Text = "Squirtle", Value = 7 },
                    new { Text = "Stantler", Value = 234 },
                    new { Text = "Staraptor", Value = 398 },
                    new { Text = "Staravia", Value = 397 },
                    new { Text = "Starly", Value = 396 },
                    new { Text = "Starmie", Value = 121 },
                    new { Text = "Staryu", Value = 120 },
                    new { Text = "Steelix", Value = 208 },
                    new { Text = "Stoutland", Value = 508 },
                    new { Text = "Stunfisk", Value = 618 },
                    new { Text = "Stunky", Value = 434 },
                    new { Text = "Sudowoodo", Value = 185 },
                    new { Text = "Suicune", Value = 245 },
                    new { Text = "Sunflora", Value = 192 },
                    new { Text = "Sunkern", Value = 191 },
                    new { Text = "Surskit", Value = 283 },
                    new { Text = "Swablu", Value = 333 },
                    new { Text = "Swadloon", Value = 541 },
                    new { Text = "Swalot", Value = 317 },
                    new { Text = "Swampert", Value = 260 },
                    new { Text = "Swanna", Value = 581 },
                    new { Text = "Swellow", Value = 277 },
                    new { Text = "Swinub", Value = 220 },
                    new { Text = "Swirlix", Value = 684 },
                    new { Text = "Swoobat", Value = 528 },
                    new { Text = "Sylveon", Value = 700 },
                    new { Text = "Taillow", Value = 276 },
                    new { Text = "Talonflame", Value = 663 },
                    new { Text = "Tangela", Value = 114 },
                    new { Text = "Tangrowth", Value = 465 },
                    new { Text = "Tauros", Value = 128 },
                    new { Text = "Teddiursa", Value = 216 },
                    new { Text = "Tentacool", Value = 72 },
                    new { Text = "Tentacruel", Value = 73 },
                    new { Text = "Tepig", Value = 498 },
                    new { Text = "Terrakion", Value = 639 },
                    new { Text = "Throh", Value = 538 },
                    new { Text = "Thundurus", Value = 642 },
                    new { Text = "Timburr", Value = 532 },
                    new { Text = "Tirtouga", Value = 564 },
                    new { Text = "Togekiss", Value = 468 },
                    new { Text = "Togepi", Value = 175 },
                    new { Text = "Togetic", Value = 176 },
                    new { Text = "Torchic", Value = 255 },
                    new { Text = "Torkoal", Value = 324 },
                    new { Text = "Tornadus", Value = 641 },
                    new { Text = "Torterra", Value = 389 },
                    new { Text = "Totodile", Value = 158 },
                    new { Text = "Toxicroak", Value = 454 },
                    new { Text = "Tranquill", Value = 520 },
                    new { Text = "Trapinch", Value = 328 },
                    new { Text = "Treecko", Value = 252 },
                    new { Text = "Trevenant", Value = 709 },
                    new { Text = "Tropius", Value = 357 },
                    new { Text = "Trubbish", Value = 568 },
                    new { Text = "Turtwig", Value = 387 },
                    new { Text = "Tympole", Value = 535 },
                    new { Text = "Tynamo", Value = 602 },
                    new { Text = "Typhlosion", Value = 157 },
                    new { Text = "Tyranitar", Value = 248 },
                    new { Text = "Tyrantrum", Value = 697 },
                    new { Text = "Tyrogue", Value = 236 },
                    new { Text = "Tyrunt", Value = 696 },
                    new { Text = "Umbreon", Value = 197 },
                    new { Text = "Unfezant", Value = 521 },
                    new { Text = "Unown", Value = 201 },
                    new { Text = "Ursaring", Value = 217 },
                    new { Text = "Uxie", Value = 480 },
                    new { Text = "Vanillish", Value = 583 },
                    new { Text = "Vanillite", Value = 582 },
                    new { Text = "Vanilluxe", Value = 584 },
                    new { Text = "Vaporeon", Value = 134 },
                    new { Text = "Venipede", Value = 543 },
                    new { Text = "Venomoth", Value = 49 },
                    new { Text = "Venonat", Value = 48 },
                    new { Text = "Venusaur", Value = 3 },
                    new { Text = "Vespiquen", Value = 416 },
                    new { Text = "Vibrava", Value = 329 },
                    new { Text = "Victini", Value = 494 },
                    new { Text = "Victreebel", Value = 71 },
                    new { Text = "Vigoroth", Value = 288 },
                    new { Text = "Vileplume", Value = 45 },
                    new { Text = "Virizion", Value = 640 },
                    new { Text = "Vivillon", Value = 666 },
                    new { Text = "Volbeat", Value = 313 },
                    new { Text = "Volcanion", Value = 721 },
                    new { Text = "Volcarona", Value = 637 },
                    new { Text = "Voltorb", Value = 100 },
                    new { Text = "Vullaby", Value = 629 },
                    new { Text = "Vulpix", Value = 37 },
                    new { Text = "Wailmer", Value = 320 },
                    new { Text = "Wailord", Value = 321 },
                    new { Text = "Walrein", Value = 365 },
                    new { Text = "Wartortle", Value = 8 },
                    new { Text = "Watchog", Value = 505 },
                    new { Text = "Weavile", Value = 461 },
                    new { Text = "Weedle", Value = 13 },
                    new { Text = "Weepinbell", Value = 70 },
                    new { Text = "Weezing", Value = 110 },
                    new { Text = "Whimsicott", Value = 547 },
                    new { Text = "Whirlipede", Value = 544 },
                    new { Text = "Whiscash", Value = 340 },
                    new { Text = "Whismur", Value = 293 },
                    new { Text = "Wigglytuff", Value = 40 },
                    new { Text = "Wingull", Value = 278 },
                    new { Text = "Wobbuffet", Value = 202 },
                    new { Text = "Woobat", Value = 527 },
                    new { Text = "Wooper", Value = 194 },
                    new { Text = "Wormadam", Value = 413 },
                    new { Text = "Wurmple", Value = 265 },
                    new { Text = "Wynaut", Value = 360 },
                    new { Text = "Xatu", Value = 178 },
                    new { Text = "Xerneas", Value = 716 },
                    new { Text = "Yamask", Value = 562 },
                    new { Text = "Yanma", Value = 193 },
                    new { Text = "Yanmega", Value = 469 },
                    new { Text = "Yveltal", Value = 717 },
                    new { Text = "Zangoose", Value = 335 },
                    new { Text = "Zapdos", Value = 145 },
                    new { Text = "Zebstrika", Value = 523 },
                    new { Text = "Zekrom", Value = 644 },
                    new { Text = "Zigzagoon", Value = 263 },
                    new { Text = "Zoroark", Value = 571 },
                    new { Text = "Zorua", Value = 570 },
                    new { Text = "Zubat", Value = 41 },
                    new { Text = "Zweilous", Value = 634 },
                    new { Text = "Zygarde", Value = 718 },
                    new { Text = "-???-", Value = 722 }
                    };


            ComboBox[] box = cbtable();
            for (int i = 0; i < box.Length; i++)
            {
                box[i].DataSource = new BindingSource(species_list, null);
                box[i].DisplayMember = "Text";
                box[i].ValueMember = "Value";
            }
        }
        bool b2w2 = false;
        int[] offset = {0,0,0,0};
        byte[,] videos = new Byte[4,0x18A4];
        byte[] ebvput = new Byte[0x18A4];
        byte[,] data = new Byte[4, 0x17E0];
        byte[] input = new Byte[524288];
        string savfilter = "Save File|*.sav|Battle Video|*.ebv";
        string openfilter = "Save File|*.sav";

        private string bytes2text(byte[,] videos, int v, int o)
        {
            string charstring;

            if (videos[v, o] + 0x100 * videos[v, o + 1] == 0xFFFF)
            {
                savfilter = "Save File|*.sav";
                G_A.Visible = false;
                G_B.Visible = false;
                return "No Video";
            }
            else if (videos[v, o] + 0x100 * videos[v, o + 1] == 0x0000)
            {
                savfilter = "Save File|*.sav|Battle Video|*.ebv";
                G_A.Visible = true;
                G_B.Visible = true;
                return "Self";
            }
            else
            {
                savfilter = "Save File|*.sav|Battle Video|*.ebv";
                G_A.Visible = true;
                G_B.Visible = true;
            }

            charstring = ((char)(videos[v, o] + videos[v, o + 1])).ToString();
            for (int i = 1; i <= 12; i++)
            {
                if (videos[v, o + 2 * i] + 0x100 * videos[v, o + 2 * i + 1] == 0xFFFF)
                {
                    return charstring;
                }
                charstring += ((char)(videos[v, o + 2 * i] + 0x100 * videos[v, o + 2 * i + 1])).ToString();
            }
            return charstring;
        }
        private void loadsav(byte[] buff)
        {
            offset = getoffset(b2w2);
            B_Save.Enabled = true;
            C_Video.Enabled = true;
            openfilter = "Save File|*.sav|Battle Video|*.ebv";
            savfilter = "Save File|*.sav|Battle Video|*.ebv";
            G_A.Enabled = true;
            G_B.Enabled = true;
            G_D.Enabled = true;
            
            for (int i = 0; i < 4; i++)
            {
                // Load the data into individual arrays
                for (int j=0; j<0x18A4; j++)
                {
                    videos[i, j] = buff[offset[i] + j];
                }
            }

            // Set Index of CB to 0, triggers an update
            C_Video.SelectedIndex = 0;
            updatebv();
        }
        private void loadebv(byte[] ebv)
        {
            int i = C_Video.SelectedIndex;
            offset = getoffset(b2w2);
            for (int j = 0; j < 0x18A4; j++)
            {
                videos[i, j] = ebv[j];
            }
            // Load Battle Video
            updatebv();
        }
        private uint revr32(uint seed)
        {
            seed *= 0xEEB9EB65;
	        seed += 0x0A3561A1;
	        seed &= 0xFFFFFFFF;
            return seed;
        }
        private uint rand32(uint seed)
        {
            seed *= 0x41C64E6D;
            seed += 0x00006073;
            seed &= 0xFFFFFFFF;
            return seed;
        }
        private uint getorigin(int v)
        {
            // Get the Unencrypted Values:
            uint a1 = ((uint)(videos[v, 0xCC] + ((videos[v, 0xCD]) << 8))^0x8965);
            uint a2 = ((uint)(videos[v, 0xCE] + ((videos[v, 0xCF]) << 8))^0x6C07);
            uint a3 = ((uint)(videos[v, 0xD0] + ((videos[v, 0xD1]) << 8))^0x8B65);
            uint a4 = ((uint)(videos[v, 0xD2] + ((videos[v, 0xD3]) << 8))^0x5D58);
            uint a5 = ((uint)(videos[v, 0xD4] + ((videos[v, 0xD5]) << 8))^0x9EC3);
            for (uint i = 0; i < 0x10000; i++ )
            {
                uint seed = (a1 << 16) + i;
                if (((rand32(seed) >> 16) == a2) && ((rand32(rand32(seed)) >> 16) == a3) && ((rand32(rand32(rand32(seed))) >> 16) == a4) && ((rand32(rand32(rand32(rand32(seed)))) >> 16) == a5))
                {
                    return revr32(revr32(revr32(revr32(revr32(seed)))));
                }
            }
            MessageBox.Show("Decryption Error", "Error");
            return 0;
        }

        private void decryptdata()
        {
            // Decrypt Video Data
            int i = C_Video.SelectedIndex;
            {
                if ((videos[i, 0] + (videos[i, 1] * 0x100) != 0xFFFF))
                {
                    // Get the Decryption Seed
                    uint seed = getorigin(i);

                    // Decrypt the field
                    for (int j = 0; j < 0x17E0; j += 2)
                    {
                        uint val = (uint)(videos[i, 0xC4 + j] + ((videos[i, 0xC4 + j + 1]) << 8));
                        seed = rand32(seed);
                        uint dval = (seed >> 16) ^ (val);
                        data[i, j] = (byte)(dval & 0xFF);
                        data[i, j + 1] = (byte)(dval >> 8);
                    }
                }
            }
        }
        private void writevideos()
        {
            for (int i = 0; i < 4; i++)
            {
                // Load the data into individual arrays
                for (int j = 0; j < 0x18A0; j++)
                {
                    input[offset[i] + j] = videos[i, j];
                }

                // Write Postdata
                ushort crc = ccitt(data, i);
                input[offset[i] + 0x18A0] = (byte)(crc & 0xFF);
                input[offset[i] + 0x18A1] = (byte)(crc >> 8);
                input[offset[i] + 0x18A2] = 0;
                input[offset[i] + 0x18A3] = 0;
                input[offset[i] + 0x18A4] = 1;
                input[offset[i] + 0x18A5] = 0;

                byte[] array_crc1 = new Byte[0x18A4];
                for (int x = 0; x < 0x18A4; x++)
                {
                    array_crc1[x] = input[offset[i] + x];
                }
                ushort crc1 = ccitt2(array_crc1);

                input[offset[i] + 0x18A6] = (byte)(crc1 & 0xFF);
                input[offset[i] + 0x18A7] = (byte)(crc1 >> 8);

                for (int x = 0; x < 0x58; x++)
                {
                    input[offset[i] + 0x18A8 + x] = 0xFF;
                }

                input[offset[i] + 0x1900] = (byte)(crc1 & 0xFF);
                input[offset[i] + 0x1901] = (byte)(crc1 >> 8);
                input[offset[i] + 0x1902] = 0;
                input[offset[i] + 0x1903] = 0;
                input[offset[i] + 0x1904] = 1;
                input[offset[i] + 0x1905] = 0;
                input[offset[i] + 0x1906] = 0;
                input[offset[i] + 0x1907] = 0;

                input[offset[i] + 0x1908] = 0x14;
                input[offset[i] + 0x1909] = 0x19;
                input[offset[i] + 0x190A] = 0x00;
                input[offset[i] + 0x190B] = 0x00;
                input[offset[i] + 0x190C] = 0x27;
                input[offset[i] + 0x190D] = 0x35;
                input[offset[i] + 0x190E] = 0x05;
                input[offset[i] + 0x190F] = 0x31;
                input[offset[i] + 0x1910] = 0x00;
                input[offset[i] + 0x1911] = 0x00;

                byte[] array_crc2 = new Byte[4];
                array_crc2[0] = (byte)(crc1 & 0xFF);
                array_crc2[1] = (byte)(crc1 >> 8);
                array_crc2[2] = (byte)0;
                array_crc2[3] = (byte)0;
                ushort crc2 = ccitt2(array_crc2);
                input[offset[i] + 0x1912] = (byte)(crc2 & 0xFF);
                input[offset[i] + 0x1913] = (byte)(crc2 >> 8);
            }
        }
        private void updatebv()
        {
            // Update Battle Video Fields
            int v = C_Video.SelectedIndex;
            T_Uploader.Text = bytes2text(videos,v,0);

            // Update Species
            ComboBox[] box = cbtable();
            if (T_Uploader.Text != "No Video")
            {
                G_A.Visible = true;
                G_B.Visible = true;
                G_D.Visible = true;
                L_N.Visible = false;
                decryptdata();
                for (int i = 0; i < box.Length; i++)
                {
                    box[i].Visible = true;
                    box[i].SelectedValue = videos[v, 0x80 + 2 * i] + videos[v, 0x80 + 2 * i + 1] * 0x100;
                    if (box[i].SelectedIndex == 0)
                    {
                        box[i].Visible = false;
                    }
                }

                // Load Decrypted Data Fields
                T_OTA.Text = bytes2text(data, v, 0x1790 - 0xC4);
                T_TIDA.Text = ((uint)(data[v, 0x17A0 - 0xC4] + ((data[v, 0x17A1 - 0xC4]) << 8))).ToString();
                T_SIDA.Text = ((uint)(data[v, 0x17A2 - 0xC4] + ((data[v, 0x17A3 - 0xC4]) << 8))).ToString();

                T_OTB.Text = bytes2text(data, v, 0x17D4 - 0xC4);
                T_TIDB.Text = ((uint)(data[v, 0x17E4 - 0xC4] + ((data[v, 0x17E5 - 0xC4]) << 8))).ToString();
                T_SIDB.Text = ((uint)(data[v, 0x17E6 - 0xC4] + ((data[v, 0x17E7 - 0xC4]) << 8))).ToString();

                UInt64 bid = videos[v, 0xB8];
                bid += ((ulong)(videos[v, 0xB9])) << 8;
                bid += ((ulong)(videos[v, 0xBA])) << 16;
                bid += ((ulong)(videos[v, 0xBB])) << 24;
                bid += ((ulong)(videos[v, 0xBC])) << 32;

                T_BID.Text = bid.ToString();
                T_Facility.Text = videos[v, 0xA6].ToString();

            }
            else
            {
                G_A.Visible = false;
                G_B.Visible = false;
                G_D.Visible = false;
                L_N.Visible = true;
            }
        }
        private int[] getoffset(bool b2w2)
        {
            if (b2w2)
            {
                // Populate the Videos
                int[] os = { 0x4C000, 0x4DA00, 0x4F400, 0x50E00 };
                return os;
            }
            else
            {
                int[] os = { 0x4A000, 0x4C000, 0x4E000, 0x50000 };
                return os;
            }
        }
        private ComboBox[] cbtable()
        {
            ComboBox[] box = { C_A1, C_A2, C_A3, C_A4, C_A5, C_A6, C_B1, C_B2, C_B3, C_B4, C_B5, C_B6};
            return box;
        }
        private void open(object sender, EventArgs e)
        {
            // Open SAV
            OpenFileDialog file = new OpenFileDialog();
            file.Filter = openfilter;

            if (file.ShowDialog() == DialogResult.OK)
            {
                string path = file.FileName;
                string ext = Path.GetExtension(path);
                if ((ext == ".sav"))
                {
                    input = File.ReadAllBytes(path);
                    if (input.Length == 524288)
                    {
                        // Valid SAV Length

                        // Detect which game
                        if ((input[0x003E2] == input[0x25F00]) && (input[0x1DBE2] == input[0x25F4C]))
                        {
                            // B2W2
                            b2w2 = true;
                            loadsav(input);
                        }
                        else if ((input[0x003E2] == input[0x23F00]) && (input[0x1DBE2] == input[0x23F4C]))
                        {
                            // BW
                            b2w2 = false;
                            loadsav(input);
                        }
                        else
                        {
                            string message = "Did not select a B2W2 or BW save file. " + input.Length;
                            string caption = "Error";
                            MessageBox.Show(message, caption);
                        }
                    }
                    else
                    {   // Invalid SAV
                        string message = "Did not load a valid save file.";
                        string caption = "Error";
                        MessageBox.Show(message, caption);
                    }
                }
                else if ((ext == ".ebv"))
                {
                    // Load an Encrypted Battle Video into the field.
                    ebvput = File.ReadAllBytes(path);
                    if (ebvput.Length == 0x18A4)
                    {
                        // Valid Input
                        int v = C_Video.SelectedIndex;
                            loadebv(ebvput);
                    }
                    else
                    {   // Invalid EBV
                        string message = "Did not load a valid video file.";
                        string caption = "Error";
                        MessageBox.Show(message, caption);
                    }
                }
                else
                {
                    string message = "Did not load a valid file.";
                    string caption = "Error";
                    MessageBox.Show(message, caption);
                }
            }
        }
        private void save(object sender, EventArgs e)
        {
            // Save SAV
            // Setup SAV stuff.
            SaveFileDialog file = new SaveFileDialog();
            file.Filter = savfilter;
            if (file.ShowDialog() == DialogResult.OK)
            {
                string path = file.FileName;
                string ext = Path.GetExtension(path);
                if ((ext == ".sav"))
                {
                    // Save a Save File
                    writevideos();
                    if (File.Exists(path))
                    {
                        // File already exists, save a .bak
                        byte[] bak = File.ReadAllBytes(path);
                        File.WriteAllBytes(path + ".bak", bak);
                    }
                    File.WriteAllBytes(path, input.ToArray());
                }
                else if ((ext == ".ebv"))
                {
                    // Save a Battle Video
                    byte[] output = new Byte[0x18A4];
                    for (int i = 0; i < 0x18A4; i++)
                    {
                        // Load Battle Video
                        output[i]=videos[C_Video.SelectedIndex, i];
                    }
                    if (File.Exists(path))
                    {
                        // File already exists, save a .bak
                        byte[] bak = File.ReadAllBytes(path);
                        File.WriteAllBytes(path + ".bak", bak);
                    }
                    File.WriteAllBytes(path, output.ToArray());
                }
            }
        }
        private void about(object sender, EventArgs e)
        {
            // About Program
            string message = "Battle Video Manager\n\nBy Kaphotics";
            string caption = "About";
            MessageBox.Show(message, caption);
        }
        private void changevideo(object sender, EventArgs e)
        {
            // Change Video Loaded
            updatebv();
        }

        private ushort ccitt(byte[,] d, int v)
        {
            ushort crc = 0xFFFF;
            for (int i = 0; i < 0x17DC; i++)
            {
                crc ^= (ushort)(d[v,i] << 8);
                for (int j = 0; j < 8; j++)
                {
                    if ((crc & 0x8000) > 0)
                    {
                        crc = (ushort)((crc << 1) ^ 0x1021);
                    }
                    else
                    {
                        crc <<= 1;
                    }
                }
            }
            return crc;
        }
        private ushort ccitt2(byte[] d)
        {
            ushort crc = 0xFFFF;
            for (int i = 0; i < d.Length; i++)
            {
                crc ^= (ushort)(d[i] << 8);
                for (int j = 0; j < 8; j++)
                {
                    if ((crc & 0x8000) > 0)
                    {
                        crc = (ushort)((crc << 1) ^ 0x1021);
                    }
                    else
                    {
                        crc <<= 1;
                    }
                }
            }
            return crc;
        }
    }
}
